package com.qing.auth;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.open.util.AscSecurityHelper;
import org.open.util.HttpUtil;
import org.open.util.SignUtil;

import java.util.HashMap;
import java.util.Map;

public class OneThingDemo {
    
    /**
     * 校验签名
     */
    private static boolean checkSign(String appSecret, Map<String, Object> param) {
        String sign = (String)param.get("sign");
        String sign_c = SignUtil.createSign(appSecret, param);
        
        if (StringUtils.isBlank(sign_c) || !sign_c.equals(sign)) {
            return false;
        } else {
            return true; 
        }
    }
    
    public static boolean getJSONType(String str) {
        boolean result = false;
        if (StringUtils.isNotBlank(str)) {
            str = str.trim();
            if (str.startsWith("{") && str.endsWith("}")) {
                result = true;
            } else if (str.startsWith("[") && str.endsWith("]")) {
                result = true;
            }
        }
        return result;
    }
    
    public static void main(String[] args) throws Exception {
        String domainOrIpAddress = "https://bmfwsync.jcgov.gov.cn/rest/onethinginfor/saveOneThingInfor";
        /**
         * 注：样例代码中涉及令牌、分配CODE及密钥都经过处理，请按照项目实际信息进行替换
         */           
        String appCode = "**********";
        String appSecret = "*************";
        //上架服务模块
        String moduleCode = "***************";
        String timestamp = SignUtil.getTimeStamp();
        String nonce = SignUtil.getNonce();
        Map<String, Object> param = new HashMap<String, Object>();
        param.put("appcode", appCode);
        param.put("modulecode", moduleCode);
        param.put("timestamp", timestamp);
        param.put("nonce", nonce);
        //数据
        param.put("jlbId", "");
        param.put("userName", "ceshi");
        param.put("idCard", "***********");
        param.put("title", "测试测试测试11111");
        param.put("jointCoding", "123131321313");
        param.put("state", "0");
        param.put("applyDate", "2024-01-25 15:23:12");
        param.put("jumpUrl", "www.baidu.com");
        param.put("evaluateUrl", "www.baidu.com");
        param.put("lookEvaluateUrl", "www.baidu.com");
        param.put("type", "新生儿一件事");
        String sign = SignUtil.createSign(appSecret, param); //生成数字签名
        param.put("sign", sign);
        String data = AscSecurityHelper.encryptAES(appSecret, param); //生成加密信息
        Map<String, Object> postData = new HashMap<String, Object>();
        postData.put("appcode", appCode);
        postData.put("data", data);
        System.out.println("appcode="+ appCode);
        System.out.println("data="+ data);
        String url = domainOrIpAddress;
        String result = HttpUtil.sendPost(url, postData);
        System.out.println("返回信息："+result);
        if(!getJSONType(result)) {
            System.out.println("服务连接异常");
        }
        JSONObject obj = JSONObject.parseObject(result);
        String resp_state = obj.getString("state");
        String resp_msg = obj.getString("msg");
        if("200".equals(resp_state)) {
            System.out.println("resp_state:" + resp_state + " resp_msg:"+resp_msg);
        } else {
            System.out.println("resp_state:" + resp_state + " resp_msg:"+resp_msg);
        }
    }
}
